<template>
  <div style="width: 90%; margin-left: auto; margin-right: auto">
    <div style="margin-top: 50px">
      <q-breadcrumbs>
        <q-breadcrumbs-el label="Home" />
        <q-breadcrumbs-el label="Level Keanggotaan" />
        <q-breadcrumbs-el label="Upgrade Level Keanggotaan" />
        <q-breadcrumbs-el label="Halaman Konfirmasi" />
      </q-breadcrumbs>
    </div>
    <h5>Konfirmasi Pembayaran Level Keanggotaan</h5>
    <div v-if="konfirmasi == false">
      <div class="q-gutter-y-md" style="margin: auto" >
        <template>
          <div>
            <q-markup-table flat bordered>
              <thead class="bg-teal">
              <tr>
                <th style="text-align: center">No.</th>
                <th class="">Langganan</th>
                <th class="">Fitur</th>
                <th class="">Harga</th>
                <th class="">Metode Pembayaran</th>
                <th class=""></th>
              </tr>
              </thead>
              <tbody class="bg-grey-3">
              <tr>
                <td class="tdlangganan">1.</td>
                <td class="tdlangganan">{{ level.level_name }}</td>
                <td class="tdfiktur">
                  <p
                    class="fikturtable"
                    v-for="(itemAkses, indekss) in level.page_access.split(',')"
                    v-bind:key="indekss"
                  >
                    {{ parseInt(indekss) + 1 }}. {{ itemAkses }}
                  </p>
                </td>
                <td class="tdlangganan">{{  formatRupiah(order.total_price, "Rp.") }}</td>
                <td class="tdlangganan">{{ order.transaction[0].payment_method.toUpperCase() }}</td>
                <td class="" style="text-align: right">
                  <q-btn
                    style="margin-top: 90px"
                    color="primary"
                    :label="`Lanjutkan Pembayaran`"
                    @click="konfirmasi = true"
                  />
                  <p  style="margin-top: 10px" >'Anda akan diarahkan ke halaman pembayaran</p>
                </td>
              </tr>
              </tbody>
            </q-markup-table>
          </div>
        </template>
      </div>
    </div>
    <div
      class="q-pa-md"
      v-else
    >
      <bank-transfer
        @gagalPencegahan="gagalPencegahan"
        @tutupPencegahan="tutupPencegahan"
        v-if="this.midtrans.payment_type == 'bank_transfer'"
        :midtrans="midtrans"
      />
      <gopay
        @gagalPencegahan="gagalPencegahan"
        @tutupPencegahan="tutupPencegahan"
        v-if="this.midtrans.payment_type == 'gopay'"
        :midtrans="midtrans"
      />
    </div>
  </div>
</template>

<script>
import BankTransfer from "components/MetodePembayaran/BankTransfer";
import Gopay from "components/MetodePembayaran/Gopay";
export default {
  name: "KonfirmasiPembayaran",
  components: {
    BankTransfer,
    Gopay,
  },
  data () {
    return {
      level: null,
      order: null,
      midtrans: null,
      avoidExit: true,
      konfirmasi: false
    }
  },
  beforeMount() {
    this.getOrder()
  },
  mounted() {
  },
  beforeRouteLeave (to, from , next) {
    if (this.avoidExit) {
      this.$q.dialog({
        title: 'Meninggalkan Halaman',
        message: 'Anda masih mempunyai pembayaran yang belum di konfirmasi, Anda Yakin akan meninggalkan halaman ini?',
        cancel: true,
        persistent: false
      }).onOk(() => {
        next()
      }).onOk(() => {
        next()
      }).onCancel(() => {
        next(false)
      }).onDismiss(() => {
        next(false)
      })
    }
  },
  methods: {
    gagalPencegahan() {
      this.avoidExit = false;
    },
    tutupPencegahan() {
      this.avoidExit = true;
    },
    getOrder() {
      this.$q.loading.show()
      this.$axios.get("api/order/level")
        .then(sukses => {
          this.$q.loading.hide()
          this.level = sukses.data.level
          this.order = sukses.data.order
          this.midtrans = JSON.parse(sukses.data.order.transaction[0].midtrans)
        })
        .catch(eror => {
          this.$q.loading.hide()
          this.$router.push("/upgrade-level")
        })
    },
    formatRupiah(angka, prefix){
      var number_string = angka.replace(/[^,\d]/g, '').toString(),
        split   		= number_string.split(','),
        sisa     		= split[0].length % 3,
        rupiah     		= split[0].substr(0, sisa),
        ribuan     		= split[0].substr(sisa).match(/\d{3}/gi);
      // tambahkan titik jika yang di input sudah menjadi angka ribuan
      if(ribuan){
        let separator = sisa ? '.' : '';
        rupiah += separator + ribuan.join('.');
      }
      rupiah = split[1] != undefined ? rupiah + ',' + split[1] : rupiah;
      return prefix == undefined ? rupiah : (rupiah ? 'Rp. ' + rupiah : '');
    },
  }
}
</script>

<style lang="scss" scoped>
.fikturtable{
  margin-bottom: 1px;
}

.tdfiktur{
  text-align: left;
  vertical-align: top;
}

.tdlangganan{
  text-align: center;
  vertical-align: top;

}

</style>
<style lang="sass">
.q-table--no-wrap td
  white-space: normal

.my-sticky-header-table
  /* height or max-height is important */
  height: 310px

  .q-table__top,
  .q-table__bottom,
  thead tr:first-child th
    /* bg color is important for th; just specify one */
    background-color: #c1f4cd

  thead tr th
    position: sticky
    z-index: 1
  thead tr:first-child th
    top: 0

  /* this is when the loading indicator appears */
  &.q-table--loading thead tr:last-child th
    /* height of all previous header rows */
    top: 48px
</style>
